.686
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

.data
align 16
   ; unm1  dd  1, 14 dup (0), 0ED7A32DEh   ; 16 dwords   1 + 14 + 1
   ; unm0  dd  1, 14 dup (0), 0FFFFFFFFh

   unm1   dd 16 dup (0FFFFFFFFh)            ; fill with max unsigned integer value 16 dwords long
   unm0   dd 16 dup (0FFFFFFFFh)

   unm2   dd 32 dup (0)  ; number of dwords must be >= (equal is sufficient) the number of dwords in unm1 + unm0
   unm3   dd 32 dup (0)

   cnr1   dd 16   ; number of dwords in unm1 also just over limit of the max array index ( 0 to number-1 )
   cnr0   dd 16   ; number of dwords in unm0

   szUnm1 db 128 dup (0), 13, 10, 13, 10
   szUnm0 db 128 dup (0), 13, 10, 13, 10
   szUnm3 db 256 dup (0), 13, 10,  0,  0
   szCapt db "Large unsigned integer multiplication",0

 ;    szUnm0 db "HarryBe", 120 dup (0), 13, 10, 13, 10

align 16
   table     db "000102030405060708090A0B0C0D0E0F"
             db "101112131415161718191A1B1C1D1E1F"
             db "202122232425262728292A2B2C2D2E2F"
             db "303132333435363738393A3B3C3D3E3F"
             db "404142434445464748494A4B4C4D4E4F"
             db "505152535455565758595A5B5C5D5E5F"
             db "606162636465666768696A6B6C6D6E6F"
             db "707172737475767778797A7B7C7D7E7F"
             db "808182838485868788898A8B8C8D8E8F"
             db "909192939495969798999A9B9C9D9E9F"
             db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
             db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
             db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
             db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
             db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
             db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"

   
.code
start:

 ;      mov dl, byte ptr [bdd+esi]
 ;      mov al, dl
 ;      shr al, 4
 ;      mov cl, [szHexStr+eax]
 ;      mov [szbdd2+edi], cl        ;  szbdd2  ================
 ;      inc edi
 ;      mov al, dl
 ;      and al, 15
 ;      mov cl, [szHexStr+eax]
 ;      mov [szbdd2+edi], cl        ;  szbdd2  ================
 ;      inc edi
 ;      dec esi



   mov ebx, 0
   mov esi, 0
   mov edi, 0
   .repeat
      mov ecx, [unm0+ebx*4]
      .if ecx != 0            ; skip multiply of row if multiplying by 0
         .repeat
            mov eax, [unm1+esi*4]         ; mov edx, 0
            mul ecx
            add [unm3+edi*4+0], eax
            adc [unm3+edi*4+4], edx
            adc [unm2+edi*4+8], 0         ; in case carry propagates store in carry holder, add in later
            inc edi
            inc esi
         .until esi >= cnr1
      .endif
      mov esi, 0
      inc ebx
      mov edi, ebx
   .until ebx >= cnr0

   mov ecx, cnr1
   add ecx, cnr0
   xor eax, eax
   xor edi, edi
   clc                        ; not needed  carry value from bit 0 of eax, which was set to 0
   .repeat
      bt eax, 0               ; needed to restore carry because the .until modifies it
      mov edx, [unm2+edi*4]
      adc [unm3+edi*4], edx
      setc al                 ; save carry for next iteration of the .repeat loop
      inc edi
   .until edi >= ecx


   mov esi, 63
   mov edi, 0
   xor edx, edx
   xor ecx, ecx
   .while (edi < 64)
      mov dl, byte ptr [unm1+esi]
      mov cx, word ptr [table+edx*2]
      mov word ptr [szUnm1+edi*2], cx
      inc edi
      dec esi
   .endw

   mov esi, 63
   mov edi, 0
   xor edx, edx
   xor ecx, ecx
   .while (edi < 64)
      mov dl, byte ptr [unm0+esi]
      mov cx, word ptr [table+edx*2]
      mov word ptr [szUnm0+edi*2], cx
      inc edi
      dec esi
   .endw

   mov esi, 127
   mov edi, 0
   xor edx, edx
   xor ecx, ecx
   .while (edi < 128)
      mov dl, byte ptr [unm3+esi]
      mov cx, word ptr [table+edx*2]
      mov word ptr [szUnm3+edi*2], cx
      inc edi
      dec esi
   .endw

   invoke MessageBox, NULL, addr szUnm1, addr szCapt, MB_OK

   Invoke ExitProcess, 0
end start